## fityk 0.8.2

=== macosx/macosx/Makefile ===
# This makefile assembles fityk.app from its constiutent parts.  Run "make" to
# build the application bundle or "make dmg" to create a disk image for
# distribution.
#
# Fityk must be compiled first.  See README.txt for more information.


fityk      := ../src/wxgui/fityk
fityk_help := ../doc/fitykhelp.htb
version := $(shell sed -n 's/^AC_INIT(.*, \[\(.*\)\])$$/\1/p' ../configure.ac)


fityk.app: $(fityk) $(fityk_help) Info.plist
	-mkdir fityk.app
	-mkdir fityk.app/Contents
	-mkdir fityk.app/Contents/MacOS
	-mkdir fityk.app/Contents/Resources
	echo -n 'APPL????' > fityk.app/Contents/PkgInfo
	cp Info.plist fityk.app/Contents
	cp $(fityk) fityk.app/Contents/MacOS/fityk
	strip fityk.app/Contents/MacOS/fityk 
	cp fityk.icns fityk.app/Contents/Resources
	cp $(fityk_help) fityk.app/Contents/Resources

../src/wxgui/fityk:
	@echo
	@echo "***   You must compile fityk first   ***"
	@echo
	@exit 1

Info.plist:
	sed -e 's/=V/$(version)/g' < Info.plist.in > Info.plist

dmg: fityk.app
	hdiutil create -srcfolder fityk.app fityk.dmg

clean:
	rm -rf Info.plist fityk.app fityk.dmg

distclean: clean
	@

.PHONY: dmg clean distclean

## fityk 0.9.3~r750

=== debian/changelog ===
fityk (0.9.3~r750-1) unstable; urgency=low

  * New upstream prerelease with bugfixes

 -- Carlo Segre <segre@debian.org>  Fri, 18 Jun 2010 00:58:26 -0500

fityk (0.9.3~r740-1) unstable; urgency=low

  * Prerelease version with powder diffraction plugin
  * Make sure sample files are in right location and do not include
    the scripts for now.

 -- Carlo Segre <segre@debian.org>  Sun, 06 Jun 2010 22:52:48 -0500

fityk (0.9.2-1) unstable; urgency=low

  * New upstream release
  * Add Build-Dep to xylib-dev, boost libraries as these are no longer
    shipped with the source.
  * Add Build-Dep to zlib1g-dev, libbz2-dev libraries
  * Upgrade to Standards-Version 3.8.4 (no changes)
  * Move to package format 3.0 (quilt)

 -- Carlo Segre <segre@debian.org>  Sun, 09 May 2010 18:27:20 -0500

fityk (0.9.0-1) unstable; urgency=low

  * New upstream release
  * Add --disable-xyconvert flag until wxwidgets 2.9 is in Debian

 -- Carlo Segre <segre@debian.org>  Tue, 09 Feb 2010 23:14:36 -0600

fityk (0.8.9-1) unstable; urgency=low

  * New upstream release
  * Update Standards-Version to 3.8.3 (no changes)
  * Remove libreadline5-dev Build-Dep (see Bug #553754)
  * Clean up all lintian errors:
    - add ${misc:Depends} in all binary packages
    - add dependence to libjs-jquery and make symlink to jquery.js

 -- Carlo Segre <segre@debian.org>  Sun, 15 Nov 2009 21:52:50 -0600

fityk (0.8.8-1) unstable; urgency=low

  * New upstream release
  * Compiltion tested with gcc-4.4 and g++-4.4
  * Upgrade to Standards-Version 3.8.2 (no changes).
  * Added --with-xylibs --with-samples configuration flags.
  * Removed patch of "#include <cstring>" from src/ui.cpp.
  * Insert Education top level menu item in *.desktop file
    NOTE: This is not the right solution but conforms to the freedesktop.org 
          standard. KDE and Gnome provide a "Science" top level menu through
          their own configuration files.  XFCE4 currently does not but can be
          configured to do so.  See README.Debian for this information.

 -- Carlo Segre <segre@debian.org>  Sat, 04 Jul 2009 14:58:31 -0500

fityk (0.8.6-3) unstable; urgency=low

  * Removed leftover debian/fityk.desktop (Closes: #500090) - thanks
    to David Futcher <bobbo@ubuntu.com>.
  * Restore sourceforge redirector in debian/watch.
  * Fix reference to GPL-2.

 -- Carlo Segre <segre@debian.org>  Sun, 12 Apr 2009 13:55:45 -0500

fityk (0.8.6-2) unstable; urgency=high

  * Compile against libwxgtk2.8-dev so Help/Manual works (Closes: #499734).
  * Upgrade to Standards-Version 3.8.0 (no changes).

 -- Carlo Segre <segre@debian.org>  Mon, 22 Sep 2008 15:09:25 -0500

fityk (0.8.6-1) unstable; urgency=low

  * New upstream release

 -- Carlo Segre <segre@debian.org>  Fri, 02 May 2008 00:54:09 -0500

fityk (0.8.5-1) unstable; urgency=low

  * New upstream release
  * Reenable 3rdparty usage in build (this means using the included Boost
    libraries and removing the Build-Depends on them).

 -- Carlo Segre <segre@debian.org>  Sun, 30 Mar 2008 11:31:03 -0500

fityk (0.8.2-2) unstable; urgency=low

  * Acknowledge NMU (Closes: #455180)
  * Upgrade to Standards-Version 3.7.3 (no changes)
  * Move Homepage from description to debian/control header

 -- Carlo Segre <segre@debian.org>  Sat, 22 Mar 2008 11:29:16 -0500

fityk (0.8.2-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix gcc-4.3 FTBFS, patch by Cyril Brulebois
    <cyril.brulebois@enst-bretagne.fr>. (Closes: #455180)

 -- Marc 'HE' Brockschmidt <he@debian.org>  Sun, 16 Mar 2008 17:26:13 +0100

fityk (0.8.2-1) unstable; urgency=low

  * New upstream release
  * Restored optimization
  * Use static libraries for now
  * Don't compile python wrapper yet

 -- Carlo Segre <segre@debian.org>  Thu, 23 Aug 2007 00:20:21 -0500

fityk (0.7.8-2) unstable; urgency=low

  * Added declarations to src/numfuncs.h to allow compilation
    by g++4.3 (Closes:  #417192)
  * Don't ignore clean errors
  * Compatibility level 5
  * Comply with menu and desktop policy

 -- Carlo Segre <segre@debian.org>  Sat, 18 Aug 2007 11:08:05 -0500

fityk (0.7.8-1) unstable; urgency=low

  * New upstream release
  * Restored -O2 compiler flags - upstream has fixed g++-4.1 compile

 -- Carlo Segre <segre@debian.org>  Wed,  7 Mar 2007 18:58:33 -0600

fityk (0.7.7-1) unstable; urgency=low

  * New upstream release

 -- Carlo Segre <segre@debian.org>  Thu, 15 Feb 2007 23:46:35 -0600

fityk (0.7.6-1) unstable; urgency=low

  * New upstream release
  * Force -O1 optimization for successful compilation with g++-4.1

 -- Carlo Segre <segre@debian.org>  Sat, 16 Sep 2006 08:32:03 -0500

fityk (0.7.5-3) unstable; urgency=low

  * Added Tag: field in control, experiment for Enrico Zini

 -- Carlo Segre <segre@debian.org>  Sat,  9 Sep 2006 00:10:06 -0500

fityk (0.7.5-2) unstable; urgency=low

  * Relaxed build dependency on libwxgtk2.6.
  * Changed maintainer email to segre@debian.org

 -- Carlo Segre <segre@debian.org>  Wed,  2 Aug 2006 16:44:31 -0500

fityk (0.7.5-1) unstable; urgency=low

  * New upstream release, see /usr/share/doc/fityk/changelog.gz.

 -- Carlo Segre <segre@debian.org>  Wed,  2 Aug 2006 13:30:07 -0500

fityk (0.7.4-2) unstable; urgency=low

  * Use .desktop file from upstream instead but leave the Ubuntu-
    contributed version as an option.

 -- Carlo Segre <segre@iit.edu>  Wed,  7 Jun 2006 10:27:10 -0500

fityk (0.7.4-1) unstable; urgency=low

  * New upstream release
  * Changed to Standards Version 3.7.2
  * Added .desktop file from Phil Bull via Ubuntu maintainer
    Emmet Hikory <emmet.hikory@gmail.com> (Thanks!)

 -- Carlo Segre <segre@iit.edu>  Tue,  6 Jun 2006 09:49:14 -0500

fityk (0.7.3-1) unstable; urgency=low

  * New upstream release (Closes:  #360795)

 -- Carlo Segre <segre@iit.edu>  Tue, 11 Apr 2006 22:02:48 -0500

fityk (0.7.2-1) unstable; urgency=low

  * New upstream release
  * Transition to WxWidgets 2.6 (Build-Dep on libwxgtk2.6-dev)
  * Stop using local boost headers for compilation



=== debian/control ===
Source: fityk
Section: science
Priority: optional
Maintainer: Carlo Segre <segre@debian.org>
Build-Depends: debhelper (>> 7), libwxgtk2.8-dev (>> 2.8.0), 
   libreadline-dev, libxy-dev, libboost-dev, zlib1g-dev, libbz2-dev
Homepage: http://www.unipress.waw.pl/fityk/
Standards-Version: 3.8.4

Package: fityk
Architecture: any
Tag: field::chemistry, field::physics, implemented-in::c++, interface::x11, 
     role::program, scope::utility, uitoolkit::wxwidgets, x11::application
Depends: ${shlibs:Depends}, ${misc:Depends}, libjs-jquery
Recommends: gnuplot
Suggests: menu
Description: general-purpose nonlinear curve fitting and data analysis
 Fityk is a flexible and portable program for nonlinear fitting of analytical
 functions (especially peak-shaped) to data (usually experimental data). In
 other words, for nonlinear peak separation and analysis.
 .
 It was developed for analyzing diffraction patterns, but can be also used in
 other fields, since concepts and operations specific for crystallography are
 separated from the rest of the program.
 .
 Fityk offers various nonlinear fitting methods, subtracting background,
 calibrating data, easy placement of peaks and changing peak parameters,
 automation of common tasks with scripts, and much more. The main advantage
 of the program is flexibility - parameters of peaks can be arbitrarily
 bound to each other, eg. the width of a peak can be an independent 
 variable, can be the same as the width of another peak or can be given 
 by a complicated - common to all peaks - formula.

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)


ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O2 -g -Wall
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

config.status: configure
	dh_testdir
	-test -r /usr/share/misc/config.sub && \
	  cp -f /usr/share/misc/config.sub config.sub
	-test -r /usr/share/misc/config.guess && \
	  cp -f /usr/share/misc/config.guess config.guess
	./configure --disable-shared --enable-static \
	  --disable-xyconvert --host=$(DEB_HOST_GNU_TYPE) \
	  --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr \
	  --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info


build: build-stamp

build-stamp:  config.status
	dh_testdir
	$(MAKE)
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp 
	-rm -f config.sub config.guess
	[ ! -f Makefile ] || $(MAKE) distclean


	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	# Add here commands to install the package into debian/fityk.
	$(MAKE) install prefix=$(CURDIR)/debian/fityk/usr
	mkdir -p $(CURDIR)/debian/fityk/usr/share/pixmaps
	cp src/wxgui/img/fityk.xpm $(CURDIR)/debian/fityk/usr/share/pixmaps/
	dh_install fityk.desktop usr/share/applications/
	# Move samples into documentation directory.  Since the shared
	# libraries are not built, do not install the C, lua and python
	# test scripts.  If libfityk is built as a standalone library
	# then the scripts should be installed.
	cp samples/*.dat $(CURDIR)/debian/fityk/usr/share/doc/fityk/samples/
	cp samples/*.fit $(CURDIR)/debian/fityk/usr/share/doc/fityk/samples/
	cp samples/README $(CURDIR)/debian/fityk/usr/share/doc/fityk/samples/
#	Remove static libraries and headers for now
	rm -rf $(CURDIR)/debian/fityk/usr/lib
	rm -rf $(CURDIR)/debian/fityk/usr/include
#	Remove jquery.js and use the Debian packages instead
	rm -rf $(CURDIR)/debian/fityk/usr/share/fityk/html/_static/jquery.js

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installdocs
	dh_installexamples
	dh_installmenu
	dh_installman
	dh_installinfo
	dh_installchangelogs NEWS
	dh_link
	dh_strip
	dh_compress --exclude=.dat --exclude=.fit
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## fityk 0.9.3

=== debian/changelog ===
fityk (0.9.3-1) unstable; urgency=low

  * New upstream release
  * Upgrade to Standards-Version 3.9.0 (no changes)

 -- Carlo Segre <segre@debian.org>  Fri, 02 Jul 2010 13:35:24 -0500

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends: debhelper (>> 7), libwxgtk2.8-dev (>> 2.8.0), 
    libreadline-dev, libxy-dev, libboost-dev, zlib1g-dev, libbz2-dev
 Homepage: http://www.unipress.waw.pl/fityk/
-Standards-Version: 3.8.4
+Standards-Version: 3.9.0
 
 Package: fityk
 Architecture: any

=== debian/watch ===
version=3
http://sf.net/fityk/fityk-(.+)\.tar\.bz2	debian	uupdate
#ftp://upload.sourceforge.net/pub/sourceforge/f/fi/fityk/ \
#	fityk-(.+)\.tar\.bz2	debian	uupdate
#ftp://heanet.dl.sourceforge.net/f/fi/fityk/fityk-(.*)\.tar\.bz2	\
# debian	uupdate

## fityk 0.9.8

=== debian/changelog ===
fityk (0.9.8-3) unstable; urgency=low

  * Correct home page URL

 -- Carlo Segre <segre@debian.org>  Sat, 19 Nov 2011 15:10:51 -0600

fityk (0.9.8-2) unstable; urgency=low

  * Remove Suggests dependency on menu (Closes: #647368)
  * Add build-arch and build-indep targets in debian/rules

 -- Carlo Segre <segre@debian.org>  Sat, 12 Nov 2011 14:58:15 -0600

fityk (0.9.8-1) unstable; urgency=low

  * New upstream release
  * Link manual in /usr/share/fityk/html to 
    /usr/share/doc/fityk/html (Closes: #627331) 
  * Upgrade to Standards-Version 3.9.2 (no changes)

 -- Carlo Segre <segre@debian.org>  Sat, 11 Jun 2011 14:51:15 -0500

fityk (0.9.7-1) unstable; urgency=low

  * New upstream release (Closes: #619385)
  * Update URLs in debian/control and debian/copyright
  * Update debian/watch to point to github
  * Upgrade for Standards-Version 3.9.1 (no changes)

 -- Carlo Segre <segre@debian.org>  Thu, 24 Mar 2011 02:00:20 -0500

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,8 @@
 Maintainer: Carlo Segre <segre@debian.org>
 Build-Depends: debhelper (>> 7), libwxgtk2.8-dev (>> 2.8.0), 
    libreadline-dev, libxy-dev, libboost-dev, zlib1g-dev, libbz2-dev
-Homepage: http://www.unipress.waw.pl/fityk/
-Standards-Version: 3.9.0
+Homepage: http://fityk.nieto.pl/
+Standards-Version: 3.9.2
 
 Package: fityk
 Architecture: any
@@ -13,7 +13,6 @@
      role::program, scope::utility, uitoolkit::wxwidgets, x11::application
 Depends: ${shlibs:Depends}, ${misc:Depends}, libjs-jquery
 Recommends: gnuplot
-Suggests: menu
 Description: general-purpose nonlinear curve fitting and data analysis
  Fityk is a flexible and portable program for nonlinear fitting of analytical
  functions (especially peak-shaped) to data (usually experimental data). In

=== debian/rules ===
--- 
+++ 
@@ -22,8 +22,11 @@
 	  --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr \
 	  --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info
 
+build: build-arch build-indep
 
-build: build-stamp
+build-arch: build-stamp
+
+build-indep: build-stamp
 
 build-stamp:  config.status
 	dh_testdir

## fityk 1.2.1

=== doc/Makefile ===

# this is normal Makefile, _not_ generated by autotools

SPHINX = sphinx-build -a -d ./doctrees/

html: *.rst fityk.css conf.py
	$(SPHINX) -b html . html
	rm -f html/objects.inv html/.buildinfo

fityk-banner.pdf: fityk-banner.svg
	inkscape --export-text-to-path --export-pdf=$@ $<

pdf:
	rm -rf doctrees/
	$(SPHINX) -b latex . latex
	cd latex/ && make all-pdf

website:
	rm -rf web
	BUILD_WEBSITE=1 $(SPHINX) -b html -Awebsite=1 . web
	cp screenshots/fityk-1.0.1-osx-so.png web/_images/
	rm -f web/objects.inv web/.buildinfo
	sed -i 's/&mdash; Fityk ..... manual//' web/index.html web/screens.html

.PHONY: pdf website

=== debian/changelog ===
fityk (1.2.1-0.1ubuntu2) trusty; urgency=medium

  * Build using dh-autoreconf.
  * Fix link error, patch provided by Marcin Wojdyr.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 14 Apr 2014 17:53:27 +0200

fityk (1.2.1-0.1ubuntu1) trusty; urgency=medium

  * Pass -lstdc++ in LIBS instead of LDFLAGS to fix FTBFS with --as-needed

 -- Andreas Moog <andreas.moog@warperbbs.de>  Fri, 17 Jan 2014 20:55:51 +0100

fityk (1.2.1-0.1) unstable; urgency=low

  * Non-maintainer upload.
  * New upstream release (closes: #703150).
  * debian/control (Standards-Version): Bumped to 3.9.5.
    (Build-Depends): Replaced WX 2.8 by version 3.0. Added autotools-dev, lua.
  * debian/copyright: Minor update.
  * debian/dirs: Dropped.
  * debian/install: Added.
  * debian/links: Added link for samples.
  * debian/rules: Rewritten for dh 7 and enabled hardening.
  * debian/upstream: Added.

 -- Daniel Leidert <dleidert@debian.org>  Wed, 01 Jan 2014 23:44:22 +0100

=== debian/control ===
Source: fityk
Section: science
Priority: optional
Maintainer: Carlo Segre <segre@debian.org>
Build-Depends: autotools-dev (>> 20100122.1~),
               debhelper (>> 7),
               dh-autoreconf,
               libboost-dev,
               libbz2-dev,
               liblua5.1-0-dev,
               libreadline-dev,
               libwxgtk3.0-dev,
               libxy-dev,
               zlib1g-dev
Homepage: http://fityk.nieto.pl/
Standards-Version: 3.9.5

Package: fityk
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: gnuplot
Suggests: libjs-sphinxdoc
Description: general-purpose nonlinear curve fitting and data analysis
 Fityk is a flexible and portable program for nonlinear fitting of analytical
 functions (especially peak-shaped) to data (usually experimental data). In
 other words, for nonlinear peak separation and analysis.
 .
 It was developed for analyzing diffraction patterns, but can be also used in
 other fields, since concepts and operations specific for crystallography are
 separated from the rest of the program.
 .
 Fityk offers various nonlinear fitting methods, subtracting background,
 calibrating data, easy placement of peaks and changing peak parameters,
 automation of common tasks with scripts, and much more. The main advantage
 of the program is flexibility - parameters of peaks can be arbitrarily
 bound to each other, eg. the width of a peak can be an independent
 variable, can be the same as the width of another peak or can be given
 by a complicated - common to all peaks - formula.
 .
 libjs-sphinxdoc is necessary for the Javascript stuff in the documentation.

=== debian/rules ===
#!/usr/bin/make -f

CPPFLAGS ?= $(shell dpkg-buildflags --get CPPFLAGS) -I/usr/include/lua5.1
CFLAGS   ?= $(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS ?= $(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS  ?= $(shell dpkg-buildflags --get LDFLAGS) # -Wl,--as-needed
LIBS ?= -lstdc++

%:
	dh $@ --with autoreconf --parallel

override_dh_auto_configure:
	dh_auto_configure -- --disable-shared --enable-static \
	                     --disable-xyconvert --with-lua-suffix=5.1 \
	                     CPPFLAGS="$(CPPFLAGS)" \
	                     CFLAGS="$(CFLAGS)" \
	                     CXXFLAGS="$(CXXFLAGS)" \
	                     LDFLAGS="$(LDFLAGS)" \
			     LIBS="$(LIBS)"

override_dh_auto_install:
	dh_auto_install
	$(RM) -r $(CURDIR)/debian/fityk/usr/lib \
	         $(CURDIR)/debian/fityk/usr/include \
	         $(CURDIR)/debian/fityk/usr/share/fityk/html/_static/*.js

override_dh_installchangelogs:
	dh_installchangelogs NEWS

override_dh_compress:
	dh_compress --exclude=.dat --exclude=.fit

=== debian/watch ===
version=3
https://github.com/wojdyr/fityk/downloads \
  /downloads/wojdyr/fityk/fityk-(.*)\.tar\.bz2

## fityk 1.3.0

=== CMakeLists.txt ===
# Use autotools-based build system instead if you can.
# For now CMake limited to building libfityk and cfityk.
# But it can automatically download and build Lua, xylib and zlib!
# You still need to have Boost libraries (headers only).
# If they can't be found automatically, use -D BOOST_ROOT=C:\Path\to\boost

cmake_minimum_required(VERSION 2.8)
project(fityk C CXX)

option(DOWNLOAD_LUA "Fetch Lua from its website" ON)
option(DOWNLOAD_XYLIB "Fetch xylib from git" ON)
option(DOWNLOAD_ZLIB "Fetch zlib from its website" ON)
option(BUILD_SHARED_LIBS "Build as a shared library" ON)

# on Windows default CMAKE_INSTALL_PREFIX is Program Files/Fityk
# so it overwrites files from Fityk installer
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT AND WIN32)
  set(CMAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/inst"
      CACHE PATH "install prefix" FORCE)
endif()

# TODO: ${THIRDPARTY_INSTALL} is used during 'make' so should be user-writable,
# OTOH libraries are needed at runtime
set(THIRDPARTY_INSTALL "${CMAKE_INSTALL_PREFIX}")

if(NOT DEFINED LIB_INSTALL_DIR)
  set(LIB_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/lib)
endif()

include(ExternalProject)

if (POLICY CMP0042)
  cmake_policy(SET CMP0042 OLD)
endif()

if (MSVC)
  # C4244: '=' : conversion from 'double' to 'float', possible loss of data
  add_definitions( /wd4244 )
  # same as _CRT_SECURE_NO_WARNINGS
  add_definitions( /wd4996 )
  # warning C4275: non dll-interface class 'std::runtime_error' used as base
  # for dll-interface class ...
  add_definitions( /wd4275 )
  # warning C4251: class (e.g. std::vector<...>) needs to have dll-interface
  # to be used by clients of class ...
  add_definitions( /wd4251 )
endif()

# if we build static library we likely prefer 3rd-party libraries also static
if(NOT BUILD_SHARED_LIBS)
  set(CMAKE_FIND_LIBRARY_SUFFIXES
      ${CMAKE_STATIC_LIBRARY_SUFFIX} ${CMAKE_FIND_LIBRARY_SUFFIXES})
endif()
include_directories(${CMAKE_SOURCE_DIR})
include_directories(${CMAKE_SOURCE_DIR}/fityk) # only for fityk_lua.cpp
include_directories(${CMAKE_BINARY_DIR})

if (BUILD_SHARED_LIBS AND WIN32)
  add_definitions(-DLUA_BUILD_AS_DLL)
  add_definitions(-DLIBFITYK_DLL)
#  add_definitions(-DXYLIB_DLL=1)
endif()

find_package(Boost REQUIRED)
message(STATUS "Boost headers in: ${Boost_INCLUDE_DIR}")
include_directories(${Boost_INCLUDE_DIR})

set(thirdparty_dir ${CMAKE_SOURCE_DIR}/3rdparty)
if (DOWNLOAD_LUA)
  ExternalProject_Add(lua52-fetch
      URL "http://www.lua.org/ftp/lua-5.2.4.tar.gz"
      URL_MD5 913fdb32207046b273fdb17aad70be13
      DOWNLOAD_DIR ${thirdparty_dir}
      SOURCE_DIR ${thirdparty_dir}/lua52
      PREFIX lua52
      CONFIGURE_COMMAND ""
      BUILD_COMMAND ""
      INSTALL_COMMAND "")

  set(lua_filenames
      lapi.c lcode.c lctype.c ldebug.c ldo.c ldump.c lfunc.c lgc.c llex.c
      lmem.c lobject.c lopcodes.c lparser.c lstate.c lstring.c
      ltable.c ltm.c lundump.c lvm.c lzio.c
      lauxlib.c lbaselib.c lbitlib.c lcorolib.c ldblib.c liolib.c
      lmathlib.c loslib.c lstrlib.c ltablib.c loadlib.c linit.c)
  foreach(lua_f ${lua_filenames})
    set(lua_src ${lua_src} ${thirdparty_dir}/lua52/src/${lua_f})
  endforeach()
  set_source_files_properties(${lua_src} PROPERTIES GENERATED TRUE)
  #add_definitions(-DLUA_ANSI=1)
  add_library(lua ${lua_src})
  set(LUA_LIBRARIES lua)
  set(LUA_INCLUDE_DIR "${thirdparty_dir}/lua52/src")
  set(BUILT_LUA lua)
  add_dependencies(lua lua52-fetch)
else()
  find_package(Lua REQUIRED)
endif()
include_directories(${LUA_INCLUDE_DIR})

find_package(SWIG REQUIRED)
#include(${SWIG_USE_FILE})

if (BUILD_SHARED_LIBS)
  set(LIB_PREFIX ${CMAKE_SHARED_LIBRARY_PREFIX})
  if (WIN32)
    set(LIB_SUFFIX ${CMAKE_IMPORT_LIBRARY_SUFFIX})
  else()
    set(LIB_SUFFIX ${CMAKE_SHARED_LIBRARY_SUFFIX})
  endif()
else()
  set(LIB_PREFIX ${CMAKE_STATIC_LIBRARY_PREFIX})
  set(LIB_SUFFIX ${CMAKE_STATIC_LIBRARY_SUFFIX})
endif()

if (DOWNLOAD_ZLIB)
  ExternalProject_Add(zlib
    URL "http://zlib.net/zlib-1.2.8.tar.gz"
    URL_MD5 44d667c142d7cda120332623eab69f40
    DOWNLOAD_DIR ${thirdparty_dir}
    SOURCE_DIR ${thirdparty_dir}/zlib
    BINARY_DIR ${CMAKE_BINARY_DIR}/zlib
    PREFIX zlib
    CMAKE_ARGS -DCMAKE_C_FLAGS:STRING=${CMAKE_C_FLAGS}
               -DCMAKE_INSTALL_PREFIX:PATH=${THIRDPARTY_INSTALL}
               -DCMAKE_BUILD_TYPE:STRING=${CMAKE_BUILD_TYPE}
               -DSKIP_INSTALL_FILES=ON)
  set(ZLIB_INCLUDE_DIR "${THIRDPARTY_INSTALL}/include")
  if (NOT WIN32)
    set(ZLIB_NAME libz)
  elseif (BUILD_SHARED_LIBS)
    set(ZLIB_NAME zlib$<$<CONFIG:Debug>:d>)
  else() # static windows
    set(ZLIB_NAME zlibstatic$<$<CONFIG:Debug>:d>)
  endif()
  set(ZLIB_LIBRARIES "${THIRDPARTY_INSTALL}/lib/${ZLIB_NAME}${LIB_SUFFIX}")
  message(STATUS "Using local zlib: ${ZLIB_LIBRARIES}")
else()
  find_package(ZLIB REQUIRED)
endif()
include_directories("${ZLIB_INCLUDE_DIR}")

if (DOWNLOAD_XYLIB)
  ExternalProject_Add(xylib
    GIT_REPOSITORY https://github.com/wojdyr/xylib
    DOWNLOAD_DIR ${thirdparty_dir}
    SOURCE_DIR ${thirdparty_dir}/xylib
    BINARY_DIR ${CMAKE_BINARY_DIR}/xylib
    PREFIX xylib
    CMAKE_ARGS "-DCMAKE_CXX_FLAGS:STRING=${CMAKE_CXX_FLAGS}"
               "-DCMAKE_INSTALL_PREFIX:PATH=${THIRDPARTY_INSTALL}"
               "-DZLIB_INCLUDE_DIR=${ZLIB_INCLUDE_DIR}"
               "-DZLIB_LIBRARIES=${ZLIB_LIBRARIES}"
               -DCMAKE_BUILD_TYPE:STRING=${CMAKE_BUILD_TYPE}
               -DGUI=OFF
               "-DBoost_INCLUDE_DIR=${Boost_INCLUDE_DIR}")
  set(XY_LIBRARY "${THIRDPARTY_INSTALL}/lib/${LIB_PREFIX}xy${LIB_SUFFIX}")
  set(XY_INCLUDE_DIR "${THIRDPARTY_INSTALL}/include")
else()
  set(XY_LIBRARY xy)
endif()
include_directories("${XY_INCLUDE_DIR}")

# show warnings by default
include(CheckCXXCompilerFlag)
check_cxx_compiler_flag(-Wextra HAS_WEXTRA_FLAG)
if (HAS_WEXTRA_FLAG)
  set(EXTRA_CXX_FLAGS "-Wall -Wextra" CACHE STRING "")
endif()
set(EXTRA_CXX_FLAGS ${EXTRA_CXX_FLAGS} CACHE STRING "Flags for compiler" FORCE)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EXTRA_CXX_FLAGS}")

set(lua_runtime swig/luarun.h)
set(lua_cxx swig/fityk_lua.cpp)
add_custom_command(OUTPUT ${lua_runtime}
                   COMMAND ${CMAKE_COMMAND} -E make_directory swig
                   COMMAND ${SWIG_EXECUTABLE}
                   ARGS -lua -external-runtime ${lua_runtime})
add_custom_command(OUTPUT ${lua_cxx}
                   COMMAND ${CMAKE_COMMAND} -E make_directory swig
                   COMMAND ${SWIG_EXECUTABLE}
                   ARGS -c++ -lua -I${CMAKE_SOURCE_DIR}/fityk
                        -o ${lua_cxx}
                        ${CMAKE_SOURCE_DIR}/fityk/swig/fityk.i
                   DEPENDS fityk/fityk.h)

set_source_files_properties(fityk/swig/fityk.i PROPERTIES CPLUSPLUS ON)
#set_source_files_properties(fityk/swig/fityk.i PROPERTIES SWIG_FLAGS "-includeall")

add_library(fityk
fityk/ast.cpp        fityk/fityk.cpp      fityk/mgr.cpp        fityk/udf.cpp
fityk/bfunc.cpp      fityk/func.cpp       fityk/model.cpp      fityk/ui_api.cpp
fityk/CMPfit.cpp     fityk/GAfit.cpp      fityk/NLfit.cpp      fityk/ui.cpp
fityk/common.cpp     fityk/guess.cpp      fityk/NMfit.cpp      fityk/var.cpp
fityk/cparser.cpp    fityk/info.cpp       fityk/numfuncs.cpp   fityk/view.cpp
fityk/data.cpp       fityk/lexer.cpp      fityk/runner.cpp     fityk/vm.cpp
fityk/eparser.cpp    fityk/LMfit.cpp      fityk/settings.cpp   fityk/voigt.cpp
fityk/f_fcjasym.cpp  fityk/logic.cpp      fityk/tplate.cpp
fityk/fit.cpp        fityk/luabridge.cpp  fityk/transform.cpp
fityk/cmpfit/mpfit.c
${lua_runtime} ${lua_cxx})

if (DOWNLOAD_XYLIB)
  add_dependencies(fityk xylib)
endif()
if (DOWNLOAD_ZLIB)
  add_dependencies(fityk zlib)
endif()
if (DOWNLOAD_ZLIB AND DOWNLOAD_XYLIB)
  add_dependencies(xylib zlib)
endif()

target_link_libraries(fityk ${XY_LIBRARY} ${LUA_LIBRARIES} ${ZLIB_LIBRARIES})
set_target_properties(fityk PROPERTIES SOVERSION 4 VERSION 4.0.0)

# ignoring libreadline for now
add_executable(cfityk cli/gnuplot.cpp cli/main.cpp)
target_link_libraries(cfityk fityk)

#add_definitions(-DVERSION="1.3.0")
set_target_properties (fityk cfityk PROPERTIES
                       COMPILE_DEFINITIONS VERSION="1.3.0")


#swig_add_module(fityk python fityk/swig/fityk.i fityk/ui_api.h)
#swig_link_libraries(fityk fityk ${PYTHON_LIBRARIES})


install(TARGETS cfityk DESTINATION bin)
install(TARGETS fityk ${BUILT_LUA}
        RUNTIME DESTINATION bin
        ARCHIVE DESTINATION "${LIB_INSTALL_DIR}"
        LIBRARY DESTINATION "${LIB_INSTALL_DIR}")


enable_testing()
if (NOT EXISTS "${CMAKE_SOURCE_DIR}/tests/catch.hpp")
  message(STATUS "Downloading catch.hpp...")
  file(DOWNLOAD
       https://raw.githubusercontent.com/philsquared/Catch/develop/single_include/catch.hpp
       "${CMAKE_SOURCE_DIR}/tests/catch.hpp" SHOW_PROGRESS)
endif()
add_library(catch STATIC tests/catch.cpp)
foreach(t gradient guess psvoigt num lua)
  add_executable(test_${t} tests/${t}.cpp)
  target_link_libraries(test_${t} fityk catch)
  add_test(NAME ${t} COMMAND $<TARGET_FILE:test_${t}>)
endforeach()

=== debian/changelog ===
fityk (1.3.0-1) unstable; urgency=medium

  * New upstream release (Closes: #747161):
    - Builds successfully with GCC 6 (Closes: #811800).
  * Update build system to suit new upstream:
    - Remove no-longer-needed compiler/linker FLAGS setting (Closes: #735777)
    - Update build-dependencies on lua
    - Add build-dependency on
        - 'swig' to build bindings
        - 'check' to run tests
        - 'texlive-latex-*', 'sphinx', 'dvipng' to build documentation
  * Switch to debhelper compat level 10, allowing debhelper to do the necessary
    autoreconf automatically (Closes: #744571)
  * Move d/upstream to d/upstream/metadata
  * Fix watch file to correctly find new releases.
  * Bump Standards-Version to 3.9.8 (no changes required).
  * Drop no-longer-needed menu file as per #741573.
  * Add DEP-8 tests using cfityk.
  * Bring package into Debian Science and add me as an uploader, with thanks
    to Carlo Segre for many years of work.

 -- Stuart Prescott <stuart@debian.org>  Sun, 06 Nov 2016 16:20:37 +1100

=== debian/control ===
--- 
+++ 
@@ -1,25 +1,40 @@
 Source: fityk
 Section: science
 Priority: optional
-Maintainer: Carlo Segre <segre@debian.org>
-Build-Depends: autotools-dev (>> 20100122.1~),
-               debhelper (>> 7),
-               dh-autoreconf,
-               libboost-dev,
-               libbz2-dev,
-               liblua5.1-0-dev,
-               libreadline-dev,
-               libwxgtk3.0-dev,
-               libxy-dev,
-               zlib1g-dev
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Uploaders:
+ Carlo Segre <segre@debian.org>,
+ Stuart Prescott <stuart@debian.org>
+Build-Depends:
+ catch,
+ debhelper (>> 10),
+ dvipng,
+ libboost-dev,
+ libbz2-dev,
+ liblua5.2-dev,
+ libreadline-dev,
+ libwxgtk3.0-dev,
+ libxy-dev,
+ lua5.2,
+ python3-sphinx,
+ swig,
+ texlive-latex-extra,
+ texlive-latex-recommended,
+ zlib1g-dev
 Homepage: http://fityk.nieto.pl/
-Standards-Version: 3.9.5
+Standards-Version: 3.9.8
+Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/fityk.git
+Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/fityk.git
 
 Package: fityk
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}
-Recommends: gnuplot
-Suggests: libjs-sphinxdoc
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends}
+Recommends:
+ gnuplot
+Suggests:
+ libjs-sphinxdoc
 Description: general-purpose nonlinear curve fitting and data analysis
  Fityk is a flexible and portable program for nonlinear fitting of analytical
  functions (especially peak-shaped) to data (usually experimental data). In

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=autoconf --parallel

override_dh_auto_configure:
	dh_auto_configure -- --disable-shared --enable-static

override_dh_auto_build:
	dh_auto_build
	make -C doc html

override_dh_auto_install:
	dh_auto_install
	$(RM) -r $(CURDIR)/debian/fityk/usr/lib \
	         $(CURDIR)/debian/fityk/usr/include \
	         $(CURDIR)/debian/fityk/usr/share/fityk/html/_static/*.js

override_dh_installchangelogs:
	dh_installchangelogs NEWS

override_dh_compress:
	dh_compress --exclude=.dat --exclude=.fit

=== debian/tests/control ===
Tests: fityk
Depends: fityk

## fityk 1.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -237,8 +237,13 @@
 if (NOT EXISTS "${CMAKE_SOURCE_DIR}/tests/catch.hpp")
   message(STATUS "Downloading catch.hpp...")
   file(DOWNLOAD
-       https://raw.githubusercontent.com/philsquared/Catch/develop/single_include/catch.hpp
-       "${CMAKE_SOURCE_DIR}/tests/catch.hpp" SHOW_PROGRESS)
+       https://raw.githubusercontent.com/philsquared/Catch/master/single_include/catch.hpp
+       "${CMAKE_SOURCE_DIR}/tests/catch.hpp" SHOW_PROGRESS
+       STATUS download_status)
+  list(GET download_status 0 status_code)
+  if (NOT ${status_code} EQUAL 0)
+    message(FATAL_ERROR "Downloading catch.hpp FAILED: ${download_status}")
+  endif()
 endif()
 add_library(catch STATIC tests/catch.cpp)
 foreach(t gradient guess psvoigt num lua)

=== doc/Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 SPHINX = sphinx-build -a -d ./doctrees/
 
-html: *.rst fityk.css conf.py
+html: *.rst fitheme/* fitheme/static/* conf.py
 	$(SPHINX) -b html . html
 	rm -f html/objects.inv html/.buildinfo

=== doc/requirements.txt ===
Sphinx>=1.5.1

=== debian/changelog ===
fityk (1.3.1-7) unstable; urgency=medium

  * Force compilation with c++-14 for compatibility with GCC-11
    (Closes: #984123).
  * Cherry-pick patch from upstream for compatibility with newer sphinx.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository.
  * Update standards version to 4.6.0, no changes needed.
  * Update watch file format version to 4.

 -- Stuart Prescott <stuart@debian.org>  Mon, 01 Nov 2021 18:51:21 +1100

fityk (1.3.1-6) unstable; urgency=medium

  [ Debian Janitor ]
  * Use secure URI in Homepage field.
  * Update standards version to 4.4.1, no changes needed.
  * Set upstream metadata fields: Repository.

  [ Stuart Prescott ]
  * Update Standards-Version to 4.5.1 (no changes required).
  * Update to debhelper-compat (= 13).

 -- Stuart Prescott <stuart@debian.org>  Mon, 21 Dec 2020 11:35:37 +1100

fityk (1.3.1-5) unstable; urgency=medium

  * Upload to unstable.

 -- Stuart Prescott <stuart@debian.org>  Fri, 27 Sep 2019 10:34:05 +1000

fityk (1.3.1-4) experimental; urgency=medium

  * Switch build to gtk3 (Closes: #933450).
  * Update Vcs-* headers to salsa.debian.org.
  * Update Standards-Version to 4.4.0 (no changes required).
  * Update to debhelper compat 12.

 -- Stuart Prescott <stuart@debian.org>  Thu, 08 Aug 2019 10:57:28 +1000

fityk (1.3.1-3) unstable; urgency=medium

  * Cherry-pick upstream fix (9684b96) to mark float comparisons in test suite
    as approximate (Closes: #876776).

 -- Stuart Prescott <stuart@debian.org>  Tue, 26 Sep 2017 13:06:38 +1000

fityk (1.3.1-2) unstable; urgency=medium

  * Use dh_sphinxdoc to get symlinks right, with thanks to Dmitry Shachnev
    for the patch (Closes: #857816).
  * Update Standards-Version to 4.1.0 (no changes required).

 -- Stuart Prescott <stuart@debian.org>  Mon, 25 Sep 2017 11:52:02 +1000

fityk (1.3.1-1) unstable; urgency=medium

  * New upstream release.
    - require newer version of sphinx to build documentation.
  * Update Standards-Version to 4.0.0 (no changes required).

 -- Stuart Prescott <stuart@debian.org>  Sun, 30 Jul 2017 10:32:00 +1000

=== debian/control ===
--- 
+++ 
@@ -7,24 +7,25 @@
  Stuart Prescott <stuart@debian.org>
 Build-Depends:
  catch,
- debhelper (>> 10),
+ debhelper-compat (=13),
  dvipng,
  libboost-dev,
  libbz2-dev,
  liblua5.2-dev,
  libreadline-dev,
- libwxgtk3.0-dev,
+ libwxgtk3.0-gtk3-dev,
  libxy-dev,
  lua5.2,
- python3-sphinx,
+ python3-sphinx (>> 1.5~),
  swig,
  texlive-latex-extra,
  texlive-latex-recommended,
  zlib1g-dev
-Homepage: http://fityk.nieto.pl/
-Standards-Version: 3.9.8
-Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/fityk.git
-Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/fityk.git
+Homepage: https://fityk.nieto.pl/
+Standards-Version: 4.6.0
+Vcs-Git: https://salsa.debian.org/science-team/fityk.git
+Vcs-Browser: https://salsa.debian.org/science-team/fityk
+Rules-Requires-Root: no
 
 Package: fityk
 Architecture: any
@@ -34,7 +35,7 @@
 Recommends:
  gnuplot
 Suggests:
- libjs-sphinxdoc
+ ${sphinxdoc:Depends}
 Description: general-purpose nonlinear curve fitting and data analysis
  Fityk is a flexible and portable program for nonlinear fitting of analytical
  functions (especially peak-shaped) to data (usually experimental data). In

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/fityk-$1\.tar\.gz/ https://github.com/wojdyr/fityk/tags .*/v?(\d\S+)\.tar\.gz

## fityk 1.3.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,18 @@
-# Use autotools-based build system instead if you can.
-# For now CMake limited to building libfityk and cfityk.
-# But it can automatically download and build Lua, xylib and zlib!
+# CMake build is limited to building libfityk, cfityk and Python module.
+# It is used only for building with fityk in Visual Studio, for example
+# on AppVeyor: https://ci.appveyor.com/project/wojdyr/fityk
+# All offical releases are prepared with autotools instead.
+
+# This build script cannot build GUI, has fewer options than the configure
+# script, but it can automatically download and build Lua, xylib and zlib!
 # You still need to have Boost libraries (headers only).
-# If they can't be found automatically, use -D BOOST_ROOT=C:\Path\to\boost
-
-cmake_minimum_required(VERSION 2.8)
+# You may need to point to them with -D BOOST_ROOT=C:\Path\to\boost
+# If you downloaded the source from git you also need SWIG.
+# On Windows it can be installed with "cinst swig".
+# When using Microsoft Visual C++ Compiler for Python 2.7 add cmake option
+# -D CMAKE_BUILD_TYPE=Release (I haven't investigated why it was needed).
+
+cmake_minimum_required(VERSION 2.8.12)
 project(fityk C CXX)
 
 option(DOWNLOAD_LUA "Fetch Lua from its website" ON)
@@ -28,10 +36,6 @@
 endif()
 
 include(ExternalProject)
-
-if (POLICY CMP0042)
-  cmake_policy(SET CMP0042 OLD)
-endif()
 
 if (MSVC)
   # C4244: '=' : conversion from 'double' to 'float', possible loss of data
@@ -99,7 +103,6 @@
 include_directories(${LUA_INCLUDE_DIR})
 
 find_package(SWIG REQUIRED)
-#include(${SWIG_USE_FILE})
 
 if (BUILD_SHARED_LIBS)
   set(LIB_PREFIX ${CMAKE_SHARED_LIBRARY_PREFIX})
@@ -115,8 +118,8 @@
 
 if (DOWNLOAD_ZLIB)
   ExternalProject_Add(zlib
-    URL "http://zlib.net/zlib-1.2.8.tar.gz"
-    URL_MD5 44d667c142d7cda120332623eab69f40
+    URL "http://zlib.net/zlib-1.2.12.tar.gz"
+    URL_HASH SHA256=91844808532e5ce316b3c010929493c0244f3d37593afd6de04f71821d5136d9
     DOWNLOAD_DIR ${thirdparty_dir}
     SOURCE_DIR ${thirdparty_dir}/zlib
     BINARY_DIR ${CMAKE_BINARY_DIR}/zlib
@@ -157,7 +160,8 @@
   set(XY_LIBRARY "${THIRDPARTY_INSTALL}/lib/${LIB_PREFIX}xy${LIB_SUFFIX}")
   set(XY_INCLUDE_DIR "${THIRDPARTY_INSTALL}/include")
 else()
-  set(XY_LIBRARY xy)
+  find_path(XY_INCLUDE_DIR xylib/xylib.h HINTS ${CMAKE_INSTALL_PREFIX}/include)
+  find_library(XY_LIBRARY NAMES xy HINTS ${LIB_INSTALL_DIR})
 endif()
 include_directories("${XY_INCLUDE_DIR}")
 
@@ -197,7 +201,7 @@
 fityk/eparser.cpp    fityk/LMfit.cpp      fityk/settings.cpp   fityk/voigt.cpp
 fityk/f_fcjasym.cpp  fityk/logic.cpp      fityk/tplate.cpp
 fityk/fit.cpp        fityk/luabridge.cpp  fityk/transform.cpp
-fityk/cmpfit/mpfit.c
+fityk/cmpfit/mpfit.c fityk/root/background.cpp
 ${lua_runtime} ${lua_cxx})
 
 if (DOWNLOAD_XYLIB)
@@ -217,13 +221,27 @@
 add_executable(cfityk cli/gnuplot.cpp cli/main.cpp)
 target_link_libraries(cfityk fityk)
 
-#add_definitions(-DVERSION="1.3.0")
+#add_definitions(-DVERSION="1.3.2")
 set_target_properties (fityk cfityk PROPERTIES
-                       COMPILE_DEFINITIONS VERSION="1.3.0")
-
-
-#swig_add_module(fityk python fityk/swig/fityk.i fityk/ui_api.h)
-#swig_link_libraries(fityk fityk ${PYTHON_LIBRARIES})
+                       COMPILE_DEFINITIONS VERSION="1.3.2")
+
+
+if(MSVC90) # compiling with VS2008? It's most likely for Python 2.7.
+  set(Python_ADDITIONAL_VERSIONS 2.7)
+endif()
+find_package(PythonLibs)
+if (PYTHONLIBS_FOUND)
+  message(STATUS "Building extension for Python ${PYTHONLIBS_VERSION_STRING}")
+  include_directories(${PYTHON_INCLUDE_DIRS})
+  include(${SWIG_USE_FILE})
+  set_property(SOURCE fityk/swig/fityk.i PROPERTY SWIG_MODULE_NAME fityk)
+  swig_add_module(fityk python fityk/swig/fityk.i fityk/ui_api.h)
+  swig_link_libraries(fityk fityk ${PYTHON_LIBRARIES})
+  string(REGEX REPLACE "\\.[0-9]+$" ""
+         py_dir python${PYTHONLIBS_VERSION_STRING})
+  install(TARGETS ${SWIG_MODULE_fityk_REAL_NAME} DESTINATION ${py_dir})
+  install(FILES ${CMAKE_BINARY_DIR}/fityk.py DESTINATION ${py_dir})
+endif()
 
 
 install(TARGETS cfityk DESTINATION bin)
@@ -231,13 +249,15 @@
         RUNTIME DESTINATION bin
         ARCHIVE DESTINATION "${LIB_INSTALL_DIR}"
         LIBRARY DESTINATION "${LIB_INSTALL_DIR}")
+install(FILES fityk/fityk.h fityk/ui_api.h DESTINATION include/fityk)
 
 
 enable_testing()
 if (NOT EXISTS "${CMAKE_SOURCE_DIR}/tests/catch.hpp")
   message(STATUS "Downloading catch.hpp...")
+# the latest version of Catch 1.x does not compile with VS 2008
   file(DOWNLOAD
-       https://raw.githubusercontent.com/philsquared/Catch/master/single_include/catch.hpp
+       https://github.com/philsquared/Catch/releases/download/v1.9.5/catch.hpp
        "${CMAKE_SOURCE_DIR}/tests/catch.hpp" SHOW_PROGRESS
        STATUS download_status)
   list(GET download_status 0 status_code)
@@ -251,3 +271,14 @@
   target_link_libraries(test_${t} fityk catch)
   add_test(NAME ${t} COMMAND $<TARGET_FILE:test_${t}>)
 endforeach()
+
+# make sure that API examples can be compiled
+add_executable(hello_cc samples/hello.cc)
+target_link_libraries(hello_cc fityk)
+add_test(NAME "helloC++" COMMAND $<TARGET_FILE:hello_cc>)
+add_executable(hello_c samples/hello.c)
+if(UNIX)
+  find_library(MATH_LIBRARY m)
+endif()
+target_link_libraries(hello_c fityk ${MATH_LIBRARY})
+add_test(NAME "helloC" COMMAND $<TARGET_FILE:hello_c>)

=== doc/Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 SPHINX = sphinx-build -a -d ./doctrees/
 
-html: *.rst fitheme/* fitheme/static/* conf.py
+html: *.rst fitheme/* fitheme/static/* conf.py help-message.txt
 	$(SPHINX) -b html . html
 	rm -f html/objects.inv html/.buildinfo
 
@@ -20,6 +20,6 @@
 	BUILD_WEBSITE=1 $(SPHINX) -b html -Awebsite=1 . web
 	cp screenshots/fityk-1.0.1-osx-so.png web/_images/
 	rm -f web/objects.inv web/.buildinfo
-	sed -i 's/&mdash; Fityk ..... manual//' web/index.html web/screens.html
+	sed -i 's/&#8212; Fityk ..... manual//' web/index.html web/screens.html
 
 .PHONY: pdf website

=== debian/changelog ===
fityk (1.3.2-2) unstable; urgency=medium

  * Team upload.
  * Transition to wxWidgets 3.2 (Closes: #1019795)

 -- Scott Talbert <swt@techie.net>  Tue, 18 Oct 2022 22:27:24 -0400

fityk (1.3.2-1) unstable; urgency=medium

  * New upstream release.
    - Drop all patches (applied upstream).
  * Update Standards-Version to 4.6.1 (no changes required).

 -- Stuart Prescott <stuart@debian.org>  Tue, 09 Aug 2022 17:55:18 +1000

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
  libbz2-dev,
  liblua5.2-dev,
  libreadline-dev,
- libwxgtk3.0-gtk3-dev,
+ libwxgtk3.2-dev,
  libxy-dev,
  lua5.2,
  python3-sphinx (>> 1.5~),
@@ -22,7 +22,7 @@
  texlive-latex-recommended,
  zlib1g-dev
 Homepage: https://fityk.nieto.pl/
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Git: https://salsa.debian.org/science-team/fityk.git
 Vcs-Browser: https://salsa.debian.org/science-team/fityk
 Rules-Requires-Root: no

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
CXXFLAGS += -std=c++14

%:
	dh $@ --buildsystem=autoconf --with sphinxdoc

override_dh_auto_configure:
	dh_auto_configure -- --disable-shared --enable-static

override_dh_auto_build:
	dh_auto_build
	make -C doc html

override_dh_auto_install:
	dh_auto_install
	$(RM) -r $(CURDIR)/debian/fityk/usr/lib \
	         $(CURDIR)/debian/fityk/usr/include

override_dh_installchangelogs:
	dh_installchangelogs NEWS

override_dh_compress:
	dh_compress --exclude=.dat --exclude=.fit

override_dh_sphinxdoc:
	dh_sphinxdoc usr/share/fityk/html
